import {
	Mode
} from '@jupyterlab/codemirror'

import CodeMirror from 'codemirror';

import 'codemirror/mode/python/python';
import 'codemirror/addon/mode/multiplex';

declare module 'codemirror' {
	function multiplexingMode(x: CodeMirror.Mode<any>, ...others: object[]): CodeMirror.Mode<any>;
	var modeInfo: any[];
}	

CodeMirror.defineMode("finesse-python", (config) => {
	let pmode = CodeMirror.getMode(config, "python");
	return CodeMirror.multiplexingMode(
		pmode,
		{
			open: /#katcode/,
			close: /(?=""")/, // Match string end without consuming it
			mode: CodeMirror.getMode(config, "text/html"),
			delimStyle: "delim"
		}
	)
});

CodeMirror.defineMIME("text/x-finesse-python", "finesse-python");

Mode.getModeInfo().push({
	name: 'Finesse Python',
	mime: "text/x-finesse-python",
	mode: 'finesse-python',
	ext: [],
});
